LeetCode 983 Minimum Cost For Tickets (dp)

244 篇文章 0 订阅
177 篇文章 0 订阅

In a country popular for train travel, you have planned some train travelling one year in advance.  The days of the year that you will travel is given as an array days.  Each day is an integer from 1 to 365.

Train tickets are sold in 3 different ways:

  • a 1-day pass is sold for costs[0]dollars;
  • a 7-day pass is sold for costs[1]dollars;
  • a 30-day pass is sold for costs[2]dollars.

The passes allow that many days of consecutive travel.  For example, if we get a 7-day pass on day 2, then we can travel for 7 days: day 2, 3, 4, 5, 6, 7, and 8.

Return the minimum number of dollars you need to travel every day in the given list of days.

 

Example 1:

Input: days = [1,4,6,7,8,20], costs = [2,7,15]
Output: 11
Explanation: 
For example, here is one way to buy passes that lets you travel your travel plan:
On day 1, you bought a 1-day pass for costs[0] = $2, which covered day 1.
On day 3, you bought a 7-day pass for costs[1] = $7, which covered days 3, 4, ..., 9.
On day 20, you bought a 1-day pass for costs[0] = $2, which covered day 20.
In total you spent $11 and covered all the days of your travel.

Example 2:

Input: days = [1,2,3,4,5,6,7,8,9,10,30,31], costs = [2,7,15]
Output: 17
Explanation: 
For example, here is one way to buy passes that lets you travel your travel plan:
On day 1, you bought a 30-day pass for costs[2] = $15 which covered days 1, 2, ..., 30.
On day 31, you bought a 1-day pass for costs[0] = $2 which covered day 31.
In total you spent $17 and covered all the days of your travel.

Note:

  1. 1 <= days.length <= 365
  2. 1 <= days[i] <= 365
  3. days is in strictly increasing order.
  4. costs.length == 3
  5. 1 <= costs[i] <= 1000

题目连接:https://leetcode.com/problems/minimum-cost-for-tickets/

题目分析:第一反应是区间dp,看了数据范围1e7应该能搞,dp[i][j]表示第i天到第j天的最小值,空间O(n^2),时间O(n^3)

121ms,击败5%

class Solution {
    public int mincostTickets(int[] days, int[] costs) {
        int n = days.length;
        int[][] dp = new int[400][400];
        int s = days[0];
        int e = days[n - 1];
        for (int i = 0; i < 400; i++) {
            Arrays.fill(dp[i], 0x3fffffff);
        }
        for (int i = 0; i < n; i++) {
            dp[days[i]][days[i]] = costs[0];
        }
        for (int len = 1; len < n; len++) {
            for (int i = 0; i + len < n; i++) {
                int j = i + len;
                if (days[j] - days[i] < 7) {
                    dp[days[i]][days[j]] = Math.min(dp[days[i]][days[j]], costs[1]);
                }
                if (days[j] - days[i] < 30) {
                    dp[days[i]][days[j]] = Math.min(dp[days[i]][days[j]], costs[2]);
                }
                for (int k = i; k < j; k++) {
                    dp[days[i]][days[j]] = Math.min(dp[days[i]][days[j]], dp[days[i]][days[k]] + dp[days[k + 1]][days[j]]);
                }
            }
        }
        return dp[s][e];
    }
}

然后发现从左往右扫就行了,空间O(n),时间O(n^2),dp[i]表示第1天到第i天的最小值

5ms,击败54%

class Solution {
    public int mincostTickets(int[] days, int[] costs) {
        int[] dp = new int[400];
        dp[1] = costs[0];
        for (int i = 2; i <= days.length; i++) {
            dp[i] = dp[i - 1] + costs[0];
            for (int j = 1; j < i; j++) {
                if (days[i - 1] - days[j - 1] < 7) {
                    dp[i] = Math.min(dp[i], dp[j - 1] + costs[1]);
                }
                if (days[i - 1] - days[j - 1] < 30) {
                    dp[i] = Math.min(dp[i], dp[j - 1] + costs[2]);
                }
            }
        }
        return dp[days.length];
    }
}

突然想到,往前的状态只有间隔为7和30的,总天数又是定值,不妨直接枚举,到某个位置时判断即可,空间O(1),时间O(n)

3ms,击败100%

class Solution {
    public int mincostTickets(int[] days, int[] costs) {
        int n = days.length;
        int[] dp = new int[366];
        for (int i = 0; i < n; i++) {
            dp[days[i]] = costs[0];
        }
        for (int i = days[0]; i <= days[n - 1]; i++) {
            dp[i] += dp[i - 1];
            dp[i] = Math.min(dp[i], (i < 7 ? 0 : dp[i - 7]) + costs[1]);
            dp[i] = Math.min(dp[i], (i < 30 ? 0 :dp[i - 30]) + costs[2]);
        }
        return dp[days[n - 1]];
    }
}

算法的魅力就在于此吧

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值